package hk.quantr.jcd;

import java.io.File;
import java.io.PrintWriter;
import java.io.StringWriter;
import java.util.spi.ToolProvider;
import javax.swing.Action;
import javax.swing.JComponent;
import javax.swing.JPanel;
import javax.swing.JToolBar;
import org.netbeans.core.spi.multiview.CloseOperationState;
import org.netbeans.core.spi.multiview.MultiViewElement;
import org.netbeans.core.spi.multiview.MultiViewElementCallback;
import org.openide.awt.UndoRedo;
import org.openide.loaders.DataObject;
import org.openide.util.Lookup;
import org.openide.util.NbBundle.Messages;
import org.openide.windows.TopComponent;

@MultiViewElement.Registration(
		displayName = "#LBL_Java_Disasm",
		//iconBase = "hk/quantr/jcd/javaLogo16_16.png",
		mimeType = "text/x-java",
		persistenceType = TopComponent.PERSISTENCE_NEVER,
		preferredID = "JavaVisual",
		position = 22000
)
@Messages("LBL_Java_Disasm=Disasm")
public final class JavaVisualElement extends JPanel implements MultiViewElement {

	private JavaDataObject obj;
	private JToolBar toolbar = new JToolBar();
	private transient MultiViewElementCallback callback;
	Lookup lkp;

	public JavaVisualElement(Lookup lkp) {
		this.lkp = lkp;
		obj = lkp.lookup(JavaDataObject.class);
		assert obj != null;
		initComponents();
		refreshjButtonActionPerformed(null);
	}

	public File changeExtension(File f, String newExtension) {
		int i = f.getName().lastIndexOf('.');
		String name = f.getName().substring(0, i);
		return new File(f.getParent(), name + newExtension);
	}

	@Override
	public String getName() {
		return "JavaVisualElement";
	}

	/**
	 * This method is called from within the constructor to initialize the form. WARNING: Do NOT modify this code. The content of this method is always regenerated by the Form
	 * Editor.
	 */
    // <editor-fold defaultstate="collapsed" desc="Generated Code">//GEN-BEGIN:initComponents
    private void initComponents() {

        jScrollPane2 = new javax.swing.JScrollPane();
        jTextPane1 = new javax.swing.JTextPane();
        jToolBar1 = new javax.swing.JToolBar();
        refreshjButton = new javax.swing.JButton();

        setLayout(new java.awt.BorderLayout());

        jScrollPane2.setViewportView(jTextPane1);

        add(jScrollPane2, java.awt.BorderLayout.CENTER);

        jToolBar1.setRollover(true);

        org.openide.awt.Mnemonics.setLocalizedText(refreshjButton, org.openide.util.NbBundle.getMessage(JavaVisualElement.class, "JavaVisualElement.refreshjButton.text")); // NOI18N
        refreshjButton.setFocusable(false);
        refreshjButton.setHorizontalTextPosition(javax.swing.SwingConstants.CENTER);
        refreshjButton.setVerticalTextPosition(javax.swing.SwingConstants.BOTTOM);
        refreshjButton.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                refreshjButtonActionPerformed(evt);
            }
        });
        jToolBar1.add(refreshjButton);

        add(jToolBar1, java.awt.BorderLayout.NORTH);
    }// </editor-fold>//GEN-END:initComponents

    private void refreshjButtonActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_refreshjButtonActionPerformed

//		TopComponent activeC = TopComponent.getRegistry().getActivated();
//		FileObject dataLookup = activeC.getLookup().lookup(FileObject.class);
//		if (dataLookup == null) {
//			return;
//		}
//		Project pro = FileOwnerQuery.getOwner(dataLookup);
//		String path = pro.getProjectDirectory().getPath();
//		System.out.println("path=" + path);
//		File projectDirectory = new File(path);
		System.out.println(lkp.lookup(DataObject.class).getPrimaryFile().getPath());
		File file = changeExtension(new File(lkp.lookup(DataObject.class).getPrimaryFile().getPath()), ".class");
		String classPath = file.getAbsolutePath().replace("src" + File.separator + "main" + File.separator + "java", "target" + File.separator + "classes");
		System.out.println(classPath);

		ToolProvider javap = ToolProvider.findFirst("javap").orElseThrow();
		StringWriter out = new StringWriter();
		PrintWriter stdout = new PrintWriter(out);
		StringWriter err = new StringWriter();
		PrintWriter stderr = new PrintWriter(err);
		int exitCode = javap.run(
				stdout,
				stderr,
				"-v", "-p", classPath);
		System.out.println("exitCode=" + exitCode);
		jTextPane1.setText(out.toString());
    }//GEN-LAST:event_refreshjButtonActionPerformed

    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JScrollPane jScrollPane2;
    private javax.swing.JTextPane jTextPane1;
    private javax.swing.JToolBar jToolBar1;
    private javax.swing.JButton refreshjButton;
    // End of variables declaration//GEN-END:variables
	@Override
	public JComponent getVisualRepresentation() {
		return this;
	}

	@Override
	public JComponent getToolbarRepresentation() {
		return toolbar;
	}

	@Override
	public Action[] getActions() {
		return new Action[0];
	}

	@Override
	public Lookup getLookup() {
		return obj.getLookup();
	}

	@Override
	public void componentOpened() {
	}

	@Override
	public void componentClosed() {
	}

	@Override
	public void componentShowing() {
	}

	@Override
	public void componentHidden() {
	}

	@Override
	public void componentActivated() {
	}

	@Override
	public void componentDeactivated() {
	}

	@Override
	public UndoRedo getUndoRedo() {
		return UndoRedo.NONE;
	}

	@Override
	public void setMultiViewCallback(MultiViewElementCallback callback) {
		this.callback = callback;
	}

	@Override
	public CloseOperationState canCloseElement() {
		return CloseOperationState.STATE_OK;
	}

}
